package com.sziit.G06.becontroller;

import com.sziit.G06.thread.CaptureThread;
import com.sziit.G06.thread.EventReadThread;
import java.awt.*;
import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;

/*
被控端(客户端):
1.打开一个端口，发送请求到服务端，表明需要连接的控制端。
2.连接到控制端，不断的截取屏幕截图传输到控制端。
3.接受从控制端发送过来的键盘、鼠标事件，实现事件回放。
*/

public class RemoteComputer extends Thread {

    private DataOutputStream output;
    private ObjectInputStream input;
    private ServerSocket server;
    private Socket socket;

    /**
     * 首先建立一个ServerSocket对象等待控制端来连接。
     * 连接成功得到对象输入流和输出流；
     * 抓取屏幕传回控制端，由线程CaptureThread实现;
     * 读控制端事件并回放，由线程EventReadThread实现；
     */
    public static void main(String[] args) throws IOException {

        //1.建立一个ServerSocket对象等待控制端来连接。
        System.out.println("等待连接.....");
        ServerSocket server = new ServerSocket(5209);

        //2.连接成功得到对象输入流和输出流；
        Socket socket = server.accept();
        System.out.println("成功连接上...\n"+socket);

        ObjectInputStream input = new ObjectInputStream(socket.getInputStream());
        DataOutputStream output=new DataOutputStream(socket.getOutputStream());

       //3.抓取屏幕传回控制端，由线程CaptureThread实现;
        try {
            new CaptureThread(output).start();
        } catch (AWTException e) {
            e.printStackTrace();
        }

        //4.读控制端事件并回放，由线程EventReadThread实现；
        new EventReadThread(input).start();//读控制端事件并回放
    }

}