package com.sziit.G06.thread;


import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.*;

/*
 * 控制端实现画面回放(即是回放被控端隔一段时间从桌面捕获的画面图片)
 * */
public class CaptureThread extends Thread{

    private DataOutputStream dataoutputstream;
    private Toolkit tk ;
    private Dimension dm ;
    private Rectangle rec;
    private Robot robot ;



    public CaptureThread(DataOutputStream dataoutputstream) throws AWTException {
        //1.获取dataoutputstream
        this.dataoutputstream = dataoutputstream;

        // 2.根据屏幕设定图片的大小
        tk = Toolkit.getDefaultToolkit();
        dm = tk.getScreenSize();
        //抓取的长方形屏幕
        rec = new Rectangle(0, 0, (int)dm.getWidth(), (int)dm.getHeight());

        //3.建立robot对象
        robot =new java.awt.Robot();
    }

   //// a.在被控制端，每隔一段一定的时间，将从桌面捕获的画面图片.
    @Override
    public void run() {
        while (true) {
//1.调用captureScreen抓取一次屏幕到缓冲区
            byte[] data = new byte[0];
            try {
                data = captureScreen();
            } catch (IOException e) {
                e.printStackTrace();
            }

//2.把缓冲器数据写到控制端
                try {
                    dataoutputstream.writeInt(data.length);
                    dataoutputstream.write(data);
                    dataoutputstream.flush();
                    try {
                        Thread.sleep(50);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                    System.out.println("网络有问题,截屏失败");
                }
            }
        }

        ////b.用javax.io.ImagIO转成一个字节数组，从而将每一个画面的数据量大小，用数据输出流往控制端发送。
    /*
     * 获取一个截屏，放回到一个字节数组
     */
    private byte[] captureScreen() throws IOException {

//获得一个屏幕的截图
        BufferedImage bimage = robot.createScreenCapture(rec);
//创建一段内存流
        ByteArrayOutputStream byout = new ByteArrayOutputStream();

        try {
//将图片数据写入内存流中
            ImageIO.write(bimage, "jpg", byout);
        } catch (IOException e) {
            System.out.println("截屏图片写入内存流中出现异常");
            e.printStackTrace();
        }
        return byout.toByteArray();

    }
}